using System;
using System.Numerics;

using Windows.Foundation;

using Microsoft.UI.Xaml.Controls;
using Microsoft.UI.Xaml.Controls.Primitives;
using Microsoft.UI.Xaml.Media;

namespace TestProject
{
    /// <summary>
    ///  
    /// </summary>
    public sealed partial class MainPage : Page
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - MainPage()

        /// <summary>
        /// 
        /// </summary>
        public MainPage()
        {
            InitializeComponent();

            this.mappingModeComboBox.SelectionChanged  += mappingModeComboBox_SelectionChanged;
            this.centerXSlider.ValueChanged            += slider_ValueChanged;
            this.centerYSlider.ValueChanged            += slider_ValueChanged;
            this.radiusXSlider.ValueChanged            += slider_ValueChanged;
            this.radiusYSlider.ValueChanged            += slider_ValueChanged;
            this.originXSlider.ValueChanged            += slider_ValueChanged;
            this.originYSlider.ValueChanged            += slider_ValueChanged;
            this.spreadMethodComboBox.SelectionChanged += spreadMethodComboBox_SelectionChanged;

            InitializeSliders();
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private
        //////////////////////////////////////////////////////////////////////////////// Event

        #region MappingMode ޺ ڽ   óϱ - mappingModeComboBox_SelectionChanged(sender, e)

        /// <summary>
        /// MappingMode ޺ ڽ   óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void mappingModeComboBox_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            this.radialGradientBrush.MappingMode = Enum.Parse<BrushMappingMode>(this.mappingModeComboBox.SelectedValue.ToString());

            InitializeSliders();
        }

        #endregion
        #region ̴   óϱ - slider_ValueChanged(sender, e)

        /// <summary>
        /// ̴   óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void slider_ValueChanged(object sender, RangeBaseValueChangedEventArgs e)
        {
            this.radialGradientBrush.Center         = new Point(this.centerXSlider.Value, this.centerYSlider.Value);
            this.radialGradientBrush.RadiusX        = this.radiusXSlider.Value;
            this.radialGradientBrush.RadiusY        = this.radiusYSlider.Value;
            this.radialGradientBrush.GradientOrigin = new Point(this.originXSlider.Value, this.originYSlider.Value);
        }

        #endregion
        #region SpreadMode ޺ ڽ   óϱ - spreadMethodComboBox_SelectionChanged(sender, e)

        /// <summary>
        /// SpreadMode ޺ ڽ   óϱ
        /// </summary>
        /// <param name="sender">̺Ʈ ߻</param>
        /// <param name="e">̺Ʈ </param>
        private void spreadMethodComboBox_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            this.radialGradientBrush.SpreadMethod = Enum.Parse<GradientSpreadMethod>(this.spreadMethodComboBox.SelectedValue.ToString());
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////// Function

        #region ̴ ʱȭϱ - InitializeSliders()

        /// <summary>
        /// ̴ ʱȭϱ
        /// </summary>
        private void InitializeSliders()
        {
            Size rectSize = Rect.ActualSize.ToSize();

            if(this.radialGradientBrush.MappingMode == BrushMappingMode.Absolute)
            {
                this.centerXSlider.Maximum = this.radiusXSlider.Maximum = this.originXSlider.Maximum = rectSize.Width;
                this.centerYSlider.Maximum = this.radiusYSlider.Maximum = this.originYSlider.Maximum = rectSize.Width;

                this.centerXSlider.Value = this.radiusXSlider.Value = this.originXSlider.Value = rectSize.Width / 2;
                this.centerYSlider.Value = this.radiusYSlider.Value = this.originYSlider.Value = rectSize.Width / 2;

                this.centerXSlider.StepFrequency = this.radiusXSlider.StepFrequency = this.originXSlider.StepFrequency = rectSize.Width  / 50;
                this.centerYSlider.StepFrequency = this.radiusYSlider.StepFrequency = this.originYSlider.StepFrequency = rectSize.Height / 50;

                this.centerXSlider.SmallChange = this.radiusXSlider.SmallChange = this.originXSlider.SmallChange = 10;
                this.centerYSlider.SmallChange = this.radiusYSlider.SmallChange = this.originYSlider.SmallChange = 10;
            }
            else
            {
                this.centerXSlider.Maximum = this.radiusXSlider.Maximum = this.originXSlider.Maximum = 1.0;
                this.centerYSlider.Maximum = this.radiusYSlider.Maximum = this.originYSlider.Maximum = 1.0;

                this.centerXSlider.Value = this.radiusXSlider.Value = this.originXSlider.Value = 0.5;
                this.centerYSlider.Value = this.radiusYSlider.Value = this.originYSlider.Value = 0.5;

                this.centerXSlider.StepFrequency = this.radiusXSlider.StepFrequency = this.originXSlider.StepFrequency = 0.02;
                this.centerYSlider.StepFrequency = this.radiusYSlider.StepFrequency = this.originYSlider.StepFrequency = 0.02;

                this.centerXSlider.SmallChange = this.radiusXSlider.SmallChange = this.originXSlider.SmallChange = 0.05;
                this.centerYSlider.SmallChange = this.radiusYSlider.SmallChange = this.originYSlider.SmallChange = 0.05;
            }
        }

        #endregion
    }
}